# `salt-call`

## Synopsis

    salt-call [options]

## Description

The salt-call command is used to run module functions locally on a minion instead of executing them from the master. Salt-call is used to run a Standalone Minion, and was originally created for troubleshooting.

The Salt Master is contacted to retrieve state files and other resources during execution unless the `--local` option is specified.

Note

`salt-call` commands execute from the current user's shell context, while `salt` commands execute from the system's default context.

## Options

--version

  Print the version of Salt that is running.

--versions-report

  Show program's dependencies and version number, and then exit

-h, --help

  Show the help message and exit

-c CONFIG_DIR, --config-dir=CONFIG_dir

  The location of the Salt configuration directory. This directory contains the configuration files for Salt master and minions. The default location on most systems is `/etc/salt`.

--hard-crash

  Raise any original exception rather than exiting gracefully Default: False

-g, --grains

  Return the information generated by the Salt grains

-m MODULE_DIRS, --module-dirs=MODULE_DIRS

  Specify an additional directory to pull modules from. Multiple directories can be provided by passing -m /--module-dirs multiple times.

-d, --doc, --documentation

  Return the documentation for the specified module or for all modules if none are specified

--master=MASTER

  Specify the master to use. The minion must be authenticated with the master. If this option is omitted, the master options from the minion config will be used. If multi masters are set up the first listed master that responds will be used.

--return RETURNER

  Set salt-call to pass the return data to one or many returner interfaces. To use many returner interfaces specify a comma delimited list of returners.

--local

  Run salt-call locally, as if there was no master running.

--file-root=FILE_ROOT

  Set this directory as the base file root.

--pillar-root=PILLAR_ROOT

  Set this directory as the base pillar root.

--retcode-passthrough

  Exit with the salt call retcode and not the salt binary retcode

--no-return-event

  Do not send the return event back to master.

--metadata

  Print out the execution metadata as well as the return. This will print out the outputter data, the return code, etc.

--id=ID

  Specify the minion id to use. If this option is omitted, the id option from the minion config will be used.

--skip-grains

  Do not load grains.

--refresh-grains-cache

  Force a refresh of the grains cache

### Logging Options

Logging options which override any settings defined on the configuration files.

-l LOG_LEVEL, --log-level=LOG_LEVEL

  Console logging log level. One of `all`, `garbage`, `trace`, `debug`, `info`, `warning`, `error`, `quiet`. Default: `warning`.

--log-file=LOG_FILE

  Log file path. Default: /var/log/salt/minion.

--log-file-level=LOG_LEVEL_LOGFILE

  Logfile logging log level. One of `all`, `garbage`, `trace`, `debug`, `info`, `warning`, `error`, `quiet`. Default: `warning`.

### Output Options

--out

  Pass in an alternative outputter to display the return of data. This outputter can be any of the available outputters:

  > `highstate`, `json`, `key`, `overstatestage`, `pprint`, `raw`, `txt`, `yaml`, and many others.

  Some outputters are formatted only for data returned from specific functions. If an outputter is used that does not support the data passed into it, then Salt will fall back on the `pprint` outputter and display the return data using the Python `pprint` standard library module.

--out-indent OUTPUT_INDENT, --output-indent OUTPUT_INDENT

  Print the output indented by the provided value in spaces. Negative values disable indentation. Only applicable in outputters that support indentation.

--out-file=OUTPUT_FILE, --output-file=OUTPUT_FILE

  Write the output to the specified file.

--out-file-append, --output-file-append

  Append the output to the specified file.

--no-color

  Disable all colored output

--force-color

  Force colored output

  Note

  When using colored output the color codes are as follows:

  `green` denotes success, `red` denotes failure, `blue` denotes changes and success and `yellow` denotes a expected future change in configuration.

--state-output=STATE_OUTPUT, --state_output=STATE_OUTPUT

  Override the configured state_output value for minion output. One of 'full', 'terse', 'mixed', 'changes' or 'filter'. Default: 'none'.

--state-verbose=STATE_VERBOSE, --state_verbose=STATE_VERBOSE

  Override the configured state_verbose value for minion output. Set to True or False. Default: none.

## See also

salt(1) salt-master(1) salt-minion(1)